package clusters

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/radanalyticsio/oshinko-cli/rest/models"
)

// DeleteSingleClusterReader is a Reader for the DeleteSingleCluster structure.
type DeleteSingleClusterReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteSingleClusterReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 204:
		result := NewDeleteSingleClusterNoContent()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	default:
		result := NewDeleteSingleClusterDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	}
}

// NewDeleteSingleClusterNoContent creates a DeleteSingleClusterNoContent with default headers values
func NewDeleteSingleClusterNoContent() *DeleteSingleClusterNoContent {
	return &DeleteSingleClusterNoContent{}
}

/*DeleteSingleClusterNoContent handles this case with default header values.

Cluster deletion response
*/
type DeleteSingleClusterNoContent struct {
}

func (o *DeleteSingleClusterNoContent) Error() string {
	return fmt.Sprintf("[DELETE /clusters/{name}][%d] deleteSingleClusterNoContent ", 204)
}

func (o *DeleteSingleClusterNoContent) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewDeleteSingleClusterDefault creates a DeleteSingleClusterDefault with default headers values
func NewDeleteSingleClusterDefault(code int) *DeleteSingleClusterDefault {
	return &DeleteSingleClusterDefault{
		_statusCode: code,
	}
}

/*DeleteSingleClusterDefault handles this case with default header values.

Unexpected error
*/
type DeleteSingleClusterDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the delete single cluster default response
func (o *DeleteSingleClusterDefault) Code() int {
	return o._statusCode
}

func (o *DeleteSingleClusterDefault) Error() string {
	return fmt.Sprintf("[DELETE /clusters/{name}][%d] deleteSingleCluster default  %+v", o._statusCode, o.Payload)
}

func (o *DeleteSingleClusterDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
