package clusters

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/radanalyticsio/oshinko-cli/rest/models"
)

/*CreateClusterCreated Cluster create response

swagger:response createClusterCreated
*/
type CreateClusterCreated struct {
	/*URL of the cluster detail page within the oshinko rest server
	  Required: true
	*/
	Location string `json:"Location"`

	// In: body
	Payload *models.SingleCluster `json:"body,omitempty"`
}

// NewCreateClusterCreated creates CreateClusterCreated with default headers values
func NewCreateClusterCreated() *CreateClusterCreated {
	return &CreateClusterCreated{}
}

// WithLocation adds the location to the create cluster created response
func (o *CreateClusterCreated) WithLocation(location string) *CreateClusterCreated {
	o.Location = location
	return o
}

// SetLocation sets the location to the create cluster created response
func (o *CreateClusterCreated) SetLocation(location string) {
	o.Location = location
}

// WithPayload adds the payload to the create cluster created response
func (o *CreateClusterCreated) WithPayload(payload *models.SingleCluster) *CreateClusterCreated {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the create cluster created response
func (o *CreateClusterCreated) SetPayload(payload *models.SingleCluster) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *CreateClusterCreated) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Location
	rw.Header().Add("Location", fmt.Sprintf("%v", o.Location))

	rw.WriteHeader(201)
	if o.Payload != nil {
		if err := producer.Produce(rw, o.Payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*CreateClusterDefault Unexpected error

swagger:response createClusterDefault
*/
type CreateClusterDefault struct {
	_statusCode int

	// In: body
	Payload *models.ErrorResponse `json:"body,omitempty"`
}

// NewCreateClusterDefault creates CreateClusterDefault with default headers values
func NewCreateClusterDefault(code int) *CreateClusterDefault {
	if code <= 0 {
		code = 500
	}

	return &CreateClusterDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the create cluster default response
func (o *CreateClusterDefault) WithStatusCode(code int) *CreateClusterDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the create cluster default response
func (o *CreateClusterDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithPayload adds the payload to the create cluster default response
func (o *CreateClusterDefault) WithPayload(payload *models.ErrorResponse) *CreateClusterDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the create cluster default response
func (o *CreateClusterDefault) SetPayload(payload *models.ErrorResponse) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *CreateClusterDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		if err := producer.Produce(rw, o.Payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
